$KCODE = 's'

def one_cycle(fname, outfn, script)
  ARGV.clear
  ARGV.push fname
  $> = open outfn, 'w'
  load script
  $>.close
end

def dir(path)
  Dir.foreach(path) do |entry|
    next if /^\./ =~ entry
    run File.join(path, entry)
  end
end

def run(path)
  if test ?d, path
    dir path
  elsif /\.txt$/i =~ path
    $stderr.print path, "\n"
    one_cycle   path          , 'out_join.tmp', 'join.rb'
    one_cycle   'out_join.tmp', path          , 'half.rb'
  end
end

run ARGV.shift || '.'

File.delete 'out_join.tmp' if test ?e, 'out_join.tmp'
