#!/usr/local/bin/ruby

require 'wide'

rin = false
lev = 0
indent = ""
string = ""

while gets
  chomp!

  case $_
  when /^$/
    lev = -1
    print "\n"
    rin = true
    next
  when /^header:/, /^footer:/
    lev = -1
    print "\n" if rin
    print
    while gets
      chomp!
      print "\n"
      print
      break if /^end\b/
    end
    rin = true
    next
  when /^#/, /^(\w+):/, /^%(\w+)=/
    lev = -1
    print "\n" if rin
    print
    rin = true
    next
  when /^%(\w+):/
    if /%/ =~ $'
      $stderr.print "exit. because maybe eternal loop.\n", $_
      exit
    end
    lev = -1
    print "\n" if rin
    print
    while gets
      chomp!
      print "\n"
      print
      break if /^%$/
    end
    rin = true
    next
  end

  rin = true
  prestr = string

  ~ /^ */
  indent = $&
  string = $'

  if /-$/ =~ string
    string.chop!
  end
  lev_now = indent.length/2
  if lev == lev_now
    print ' ' if Wide::space? prestr, string
    print string
  else
    lev = lev_now
    if / $/ =~ string
      string.chop!
    end
    print "\n", indent, string
  end
end
