#!/usr/local/bin/ruby

trap('SIGHUP') { exit }
trap 'SIGINT', 'IGNORE'

def pub(obj)
  obj.public_methods.join ' '
end

def ref(id)
  ObjectSpace._id2ref id >> 1 if id.is_a? Fixnum
end

def term
  print "terminated\n"
  exit
end

line = []
excl = []

while true
  print "% "
  begin
    $_ = gets
    term unless $_
    line.push $_
    line.shift if line.size > 13
    $_ = eval $_
    print
    print "\n"
  rescue
    er = $!.to_s << "\n"
    excl.push er
    excl.shift if excl.size > 13
    print er
    print "\n"
  end
end

